"use strict";

exports.__esModule = true;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require("styled-components");

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes3 = require("../../utils/propTypes");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fadeAnimation = (0, _styledComponents.keyframes)(["0%{opacity:0;}100%{opacity:1;}"]);

var animation = function animation(props) {
  return (0, _styledComponents.css)(["animation:", "ms ", " 0s 1 ", ";"], props.fadeDuration, props.fadeEasing, fadeAnimation);
};

// prettier-ignore
var Base = (0, _styledComponents2.default)("div").withConfig({
  displayName: "Tooltip__Base",
  componentId: "sc-19cbsjq-0"
})(["position:absolute;", ";", ";"], function (props) {
  return props.fadeDuration && props.fadeDuration > 0 && animation(props);
}, function (props) {
  return props.zIndex && "z-index: " + props.zIndex + ";";
});

var Top = (0, _styledComponents2.default)(Base).withConfig({
  displayName: "Tooltip__Top",
  componentId: "sc-19cbsjq-1"
})(["bottom:100%;left:50%;transform:translateX(-50%);margin-bottom:", "px;"], function (props) {
  return props.offset;
});

var Bottom = (0, _styledComponents2.default)(Base).withConfig({
  displayName: "Tooltip__Bottom",
  componentId: "sc-19cbsjq-2"
})(["top:100%;left:50%;transform:translateX(-50%);margin-top:", "px;"], function (props) {
  return props.offset;
});

var Left = (0, _styledComponents2.default)(Base).withConfig({
  displayName: "Tooltip__Left",
  componentId: "sc-19cbsjq-3"
})(["right:100%;top:50%;transform:translateY(-50%);margin-right:", "px;"], function (props) {
  return props.offset;
});

var Right = (0, _styledComponents2.default)(Base).withConfig({
  displayName: "Tooltip__Right",
  componentId: "sc-19cbsjq-4"
})(["left:100%;top:50%;transform:translateY(-50%);margin-left:", "px;"], function (props) {
  return props.offset;
});

var tooltips = {
  left: Left,
  top: Top,
  right: Right,
  bottom: Bottom
};

var Tooltip = function Tooltip(_ref) {
  var children = _ref.children,
      offset = _ref.offset,
      open = _ref.open,
      placement = _ref.placement,
      zIndex = _ref.zIndex,
      fadeDuration = _ref.fadeDuration,
      fadeEasing = _ref.fadeEasing;

  var Component = tooltips[placement] || tooltips.top;
  return open && _react2.default.createElement(
    Component,
    {
      offset: offset,
      zIndex: zIndex,
      fadeDuration: fadeDuration,
      fadeEasing: fadeEasing
    },
    children
  );
};

Tooltip.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes2.default.any.isRequired,
  offset: _propTypes2.default.number,
  open: _propTypes2.default.bool,
  placement: _propTypes2.default.string,
  zIndex: _propTypes2.default.number,
  fadeEasing: _propTypes3.easingPropType,
  fadeDuration: _propTypes2.default.number
} : {};

exports.default = Tooltip;
module.exports = exports["default"];